<p align="center">
  <a href="https://velocityx.dev/" target="_blank">
    <h1>VelocityX</h1>
  </a>
</p>

[**VelocityX**](https://velocityx.dev/) is a 100% free Flutter open-source minimalist UI Framework built with <a href="https://flutter.dev/" target="_blank">Flutter SDK</a> to make Flutter development easier and more joyful than ever.

## Inspired from Tailwindcss and SwiftUI.

```dart
"Web".text.white.xl4.bold.center.makeCentered().box.roundedLg.red500.shadow2xl.make().whHalf(context).centered());
```

### Show some :heart: and star the repo.

[![GitHub followers](https://img.shields.io/github/followers/iampawan.svg?style=social&label=Follow)](https://github.com/iampawan/Coronavirus-Warrior)
[![Twitter Follow](https://img.shields.io/twitter/follow/imthepk.svg?style=social)](https://twitter.com/imthepk)

[![Open Source Love](https://badges.frapsoft.com/os/v1/open-source.svg?v=102)](https://opensource.org/licenses/Apache-2.0)

# Quick start

Read the [Getting started page of VelocityX](https://velocityx.dev/#/home)

## YouTube Channel

[MTechViral](https://www.youtube.com/mtechviral)

## Facebook Group

[Let's Flutter With Dart](https://www.facebook.com/groups/425920117856409/)

## Collection of flutter apps with tutorial

[Flutter Example Apps](https://github.com/iampawan/FlutterExampleApps)

## Screenshot

<p float="left">
  <img src="https://i.imgur.com/qonwyrb.png" width="200" />
  <img src="https://i.imgur.com/LeDH00x.png" width="200" />
  <img src="https://i.imgur.com/FIAHZhU.png" width="200" />
  <img src="https://i.imgur.com/7UTmlsO.png" width="200" />
 
</p>

## Contributing

VelocityX is **100% free** and **open source**. We encourage and support an active, healthy community that accepts contributions from the public &ndash; including you. There are a couple of ways in which you can contribute to the growing community of `VelocityX`.

- Pick up any issue marked with ["good first issue"](https://github.com/iampawan/velocityx/issues?q=is%3Aopen+is%3Aissue+label%3A%22good+first+issue%22)
- Fix a bug
- Write and improve some **documentation**. Documentation is very critical to us. We would appreciate help in adding multiple languages to our docs.
- If you are a developer, feel free to check out the source and submit pull requests.
- Dig into [**CONTRIBUTING.MD**](CONTRIBUTING.md), which covers submitting bugs, requesting new features, preparing your code for a pull request, etc.
- Please don't forget to **like**, **follow**, and **star our repo**!

## Documentation

[**Installation Guide**](https://velocityx.dev/#/home)

### :heart: Found this project useful?

If you found this project useful, then please consider giving it a :star: on Github and sharing it with your friends via social media.

## Project Created & Maintained By

### Pawan Kumar

Google Developer Expert for Flutter. Passionate #Flutter, #Android Developer. #Entrepreneur #YouTuber

<a href="https://play.google.com/store/apps/dev?id=7703305844118303242&hl=en"><img src="https://github.com/aritraroy/social-icons/blob/master/play-store-icon.png?raw=true" width="60"></a> <a href="https://medium.com/@imthepk"><img src="https://github.com/aritraroy/social-icons/blob/master/medium-icon.png?raw=true" width="60"></a>
<a href="https://twitter.com/imthepk"><img src="https://github.com/aritraroy/social-icons/blob/master/twitter-icon.png?raw=true" width="60"></a>
<a href="https://linkedin.com/in/imthepk"><img src="https://github.com/aritraroy/social-icons/blob/master/linkedin-icon.png?raw=true" width="60"></a>
<a href="https://facebook.com/imthepk"><img src="https://github.com/aritraroy/social-icons/blob/master/facebook-icon.png?raw=true" width="60"></a>
<a href="https://instagram.com/codepur_ka_superhero"><img src="https://github.com/aritraroy/social-icons/blob/master/instagram-icon.png?raw=true" width="60"></a>

# Donate

> If you found this project helpful or you learned something from the source code and want to thank me, consider buying me a cup of :coffee:
>
> - [PayPal](https://www.paypal.me/imthepk/)

### Note: VelocityX is not directly and/or indirectly associated/affiliated with Flutter or Google LLC.

## Copyright-and-license

Code and documentation Copyright 2020 [Pawan Kumar](https://pawan.live). Code released under the [Apache License]. Docs released under [Creative Commons](https://creativecommons.org/licenses/by/3.0/).
